  /*  main.c - powershell
   *  Copyright (C) 1999  Matt Spong <spong@glue.umd.edu>
   *  Based from zterm.c by Michael Zucci from the libzvt docs
   *
   *  A big, puffy lotsa-shells-in-one app. 
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   */

   /*
	This code BADLY needs to be cleaned up... it's very ugly right
	now since it started out as copy-and-paste from the GTK tutorial 
	and the documentation for libzvt.  
   */

  #include <stdio.h>
  #include <unistd.h>
  #include <fcntl.h>
  #include <sys/time.h>
  #include <sys/types.h>
  #include <unistd.h>
  #include <errno.h>
  #include <string.h>
  #include <pwd.h>
  #include <stdlib.h>

  #include <gtk/gtk.h>
  #include <gdk/gdkx.h>
  #include <gdk/gdkprivate.h>
  #include <gdk/gdkkeysyms.h>

  #include <zvt/zvtterm.h>
          
  #define FONT "-misc-fixed-medium-r-normal--12-200-75-75-c-100-iso8859-1"
  #define scrollbacklines 50
  #define login_shell 0
  
  extern char      **environ;             
  static char      **env;
  static char      **env_copy;
  static int         winid_pos;
  static GtkWidget  *window = NULL;
  GtkWidget * notebook;
 
  int terms_open = 0;
  
  static void
  child_died_event (ZvtTerm *term)
  {
        gtk_widget_hide (GTK_WIDGET(term));  
  	gtk_container_remove (GTK_CONTAINER(notebook), GTK_WIDGET(term));      	
  }

  static void term_died_event (ZvtTerm *term)
  {
    zvt_term_closepty (term);
    terms_open--;
    if (!terms_open)
	    gtk_main_quit();
  }

  static void quit_proggie (GtkWidget * widget, GdkEvent * event, gpointer data)
  {
	gtk_main_quit ();
  }
  
  static void
  title_changed_event (ZvtTerm *term, VTTITLE_TYPE type, char *newtitle)
  {
  /*  switch(type) 
      {
      case VTTITLE_WINDOW:
      case VTTITLE_WINDOWICON:
        gtk_window_set_title (GTK_WINDOW (window), newtitle);
        break;
      default:
        break;
      }**/
  }

  static void
  set_hints (GtkWidget *widget)
  /*
	This function is causing problems with the window resizing,
	because it's copied from the zvt documentation and only expects
	a single terminal in the window.  Gotta fix this...
  */
  {
          ZvtTerm *term;
          GdkGeometry hints;
          GtkWidget *app;

          g_assert (widget != NULL);
          term = ZVT_TERM (widget);

          app = gtk_widget_get_toplevel(widget);
          g_assert (app != NULL);

  #define PADDING 2
          hints.base_width = (GTK_WIDGET (term)->style->klass->xthickness * 2) + PADDING;
          hints.base_height =  (GTK_WIDGET (term)->style->klass->ythickness * 2);

          hints.width_inc = term->charwidth;
          hints.height_inc = term->charheight;
          hints.min_width = hints.base_width + hints.width_inc;
          hints.min_height = hints.base_height + hints.height_inc;

          gtk_window_set_geometry_hints(GTK_WINDOW(app),
                                        GTK_WIDGET(term),
                                        &hints,
                     GDK_HINT_RESIZE_INC|GDK_HINT_MIN_SIZE|GDK_HINT_BASE_SIZE);
  }

GtkWidget * new_term (GtkWidget * notebook, gchar * command, gchar * args, gchar * title)
{
   GtkWidget *term, *scrollbar;
   enum { RIGHT, LEFT } scrollpos = LEFT;
   GString *shell, *name;
   GtkWidget * label;
   struct passwd *pw;
   gushort * colors, red[18], green[18], blue[18];
   int a,b;

   terms_open ++;
   
 /* create terminal */

    term = zvt_term_new();

    if (!term)
      {
	fprintf (stderr, "Error creating new terminal\n");
	return NULL;
      }

    zvt_term_set_font_name(ZVT_TERM (term), FONT);
    zvt_term_set_blink (ZVT_TERM (term), FALSE);
    zvt_term_set_bell (ZVT_TERM (term), TRUE);
    zvt_term_set_scrollback(ZVT_TERM (term), scrollbacklines);
    zvt_term_set_scroll_on_keystroke (ZVT_TERM (term), TRUE);
    zvt_term_set_scroll_on_output (ZVT_TERM (term), FALSE);
    zvt_term_set_background (ZVT_TERM (term), NULL, FALSE, 0);
    zvt_term_set_wordclass (ZVT_TERM (term), "-A-Za-z0-9/_:.,?+%=");
    zvt_term_set_del_key_swap (ZVT_TERM (term), TRUE);


    label = gtk_label_new (title);

    gtk_widget_show (label);
    gtk_notebook_append_page (GTK_NOTEBOOK (notebook), term, label);
    
    gtk_signal_connect (GTK_OBJECT (term),
                        "child_died",
                        GTK_SIGNAL_FUNC (child_died_event),
                        NULL);
    
    gtk_signal_connect (GTK_OBJECT (term),
                        "destroy",
                        GTK_SIGNAL_FUNC (term_died_event),
                        NULL);

    gtk_signal_connect (GTK_OBJECT (term),
                        "title_changed",
                        GTK_SIGNAL_FUNC (title_changed_event),
                        NULL);
            
    gtk_signal_connect_after (GTK_OBJECT (term),
                              "realize",
                              GTK_SIGNAL_FUNC (set_hints),
                              term);

    gtk_widget_show (term);

    /* this sets the bgcolor to black and the fgcolor to white */

    ZVT_TERM(term)->colors[16] = 0xffffffff;
    ZVT_TERM(term)->colors[17] = 0x0;

    
 /* fork the shell/program */
    switch (zvt_term_forkpty(ZVT_TERM (term), ZVT_TERM_DO_UTMP_LOG |  ZVT_TERM_DO_WTMP_LOG)) {
      case -1:
	perror("ERROR: unable to fork:");
	return NULL;
      break;
      
      case 0:

      execle (command, args, NULL, env_copy);
      
      default:
      break;
    }
  
    return term;
}

int MenuHandler (gchar * data)
{

	if (!strcmp (data, "file.newvim"))
	{
		new_term (notebook, "/usr/bin/vim", "", "vim");
	}
	else if (!strcmp (data, "file.newemacs"))
	{
		new_term (notebook, "/usr/bin/emacs-nox", "", "emacs");
	}
	else if (!strcmp (data, "file.newpico"))
	{
		new_term (notebook, "/usr/bin/pico", "/etc/passwd", "pico");
	}
	else if (!strcmp (data, "file.newbash"))
	{
		new_term (notebook, "/bin/bash", "", "bash");
	}
	else if (!strcmp (data, "file.newtcsh"))
	{
		new_term (notebook, "/bin/tcsh", "", "tcsh");
	}
	else if (!strcmp (data, "file.quit"))
	{
		gtk_main_quit();
	}

}
  
int InitMenus (GtkWidget * window)
{
	GtkWidget * menu_bar;
	GtkWidget * file_menu, * edit_menu, * help_menu;
	GtkWidget * file_newvim, * file_open, * file_save, *file_quit;
	GtkWidget * file_newpico, * file_newemacs, * file_newbash, * file_newtcsh;
	GtkWidget * separator;
	GtkWidget * file_item;
	
	file_menu = gtk_menu_new ();

	file_newvim = gtk_menu_item_new_with_label ("New vim Window");
	file_newpico = gtk_menu_item_new_with_label ("New pico Window");
	file_newemacs = gtk_menu_item_new_with_label ("New emacs Window");
	file_newbash = gtk_menu_item_new_with_label ("New bash Window");
	file_newtcsh = gtk_menu_item_new_with_label ("New tcsh Window");

	file_quit = gtk_menu_item_new_with_label ("Quit");
	
	gtk_menu_append (GTK_MENU (file_menu), file_newvim);
	gtk_menu_append (GTK_MENU (file_menu), file_newpico);
	gtk_menu_append (GTK_MENU (file_menu), file_newemacs);
	gtk_menu_append (GTK_MENU (file_menu), file_newbash);
	gtk_menu_append (GTK_MENU (file_menu), file_newtcsh);
	
	gtk_menu_append (GTK_MENU (file_menu), file_quit);
	
	gtk_signal_connect_object (GTK_OBJECT (file_newvim), "activate",
			GTK_SIGNAL_FUNC (MenuHandler),
			(gpointer) "file.newvim");
	gtk_signal_connect_object (GTK_OBJECT (file_newpico), "activate",
			GTK_SIGNAL_FUNC (MenuHandler),
			(gpointer) "file.newpico");
	gtk_signal_connect_object (GTK_OBJECT (file_newemacs), "activate",
			GTK_SIGNAL_FUNC (MenuHandler),
			(gpointer) "file.newemacs");
	gtk_signal_connect_object (GTK_OBJECT (file_newbash), "activate",
			GTK_SIGNAL_FUNC (MenuHandler),
			(gpointer) "file.newbash");
	gtk_signal_connect_object (GTK_OBJECT (file_newtcsh), "activate",
			GTK_SIGNAL_FUNC (MenuHandler),
			(gpointer) "file.newtcsh");
		

	gtk_signal_connect_object (GTK_OBJECT (file_quit), "activate",
			GTK_SIGNAL_FUNC (MenuHandler),
			(gpointer) "file.quit");
	

	gtk_widget_show (file_newvim);
	gtk_widget_show (file_newpico);
	gtk_widget_show (file_newemacs);
	gtk_widget_show (file_newbash);
	gtk_widget_show (file_newtcsh);
		
	gtk_widget_show (file_quit);


	menu_bar = gtk_menu_bar_new ();

	gtk_box_pack_start (GTK_BOX(window), menu_bar, FALSE, FALSE, 0);
	gtk_widget_show (menu_bar);

	file_item = gtk_menu_item_new_with_label ("File");
	gtk_widget_show (file_item);
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (file_item), file_menu);
	gtk_menu_bar_append (GTK_MENU_BAR (menu_bar), file_item);

}

  gint 
  main (gint argc, gchar *argv[])
  {
    int i, c, cmdindex;
    char buffer[60], **p;
    GtkWidget *term, *scrollbar, * hbox, *vbox;
    enum { RIGHT, LEFT } scrollpos = LEFT;
    GString *shell, *name;
    GtkWidget * filenotebook;
    GtkWidget * filelist;
    
    GtkWidget * label;
    GtkWidget * frame;

    gchar *temparr[1][1];
    
    char tempstr[256];	     

    /* set up terminal environment */
    env = environ;

    for (p = env; *p; p++);
      i = p - env;
    env_copy = (char **) g_malloc (sizeof (char *) * (i + 3));
    for (i = 0, p = env; *p; p++) {
      if (strncmp (*p, "TERM=", 5) == 0) {
        env_copy [i++] = "TERM=xterm";
      } else if ((strncmp (*p, "COLUMNS=", 8) == 0) ||
                 (strncmp (*p, "LINES=", 6) == 0)) {
        continue;
      } else {
        env_copy [i++] = *p;
      }
    }

    env_copy [i++] = "COLORTERM=zterm";
    winid_pos = i++;
    env_copy [winid_pos] = "TEST";
    env_copy [i] = NULL;
            
    gtk_init(&argc, &argv);

     /* process arguments */
    while ( (cmdindex==0) && (c=getopt(argc, argv, "le:s:rh")) != EOF ) {
      switch(c)  {
        case 'e':
        cmdindex = optind-1;      /* index of argv array to pass to exec */
        break;
        
        
        case 'r':
        scrollpos = RIGHT;
        break;
        
        case '?':
        case 'h':
        default:
        fprintf(stderr, "Usage: powershell [-sNN] [-l] [-r] [-e command args]\n");
	
        exit(1);
        break;
      }
    }

    /* Create widgets and set options */
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title (GTK_WINDOW (window), "PowerShell");
    gtk_window_set_wmclass (GTK_WINDOW (window), "powershell", "powershell");
    gtk_widget_realize (window);
    
    vbox = gtk_vbox_new (FALSE, 0); 
    gtk_container_add (GTK_CONTAINER (window), vbox);
    gtk_widget_show (vbox);

    InitMenus (vbox);
    
    hbox = gtk_hbox_new (FALSE, 0);
    gtk_box_set_spacing (GTK_BOX (hbox), 2);
    gtk_container_set_border_width (GTK_CONTAINER (hbox), 2);
    gtk_container_add (GTK_CONTAINER (vbox), hbox);
    gtk_widget_show (hbox);

    /*
    filenotebook = gtk_notebook_new ();
    gtk_notebook_set_tab_pos (GTK_NOTEBOOK (filenotebook), GTK_POS_TOP);

    
    gtk_box_pack_start (GTK_BOX(hbox), filenotebook, FALSE, FALSE, 0);

    temparr[0][0] = (gchar *)malloc (256);
    strcpy (temparr[0][0], "blah blah");
    
    filelist = gtk_clist_new (1);
    gtk_clist_set_selection_mode (filelist, GTK_SELECTION_SINGLE);
    gtk_clist_set_shadow_type (filelist, GTK_SHADOW_OUT); 

   
    label = gtk_label_new ("Source Files");
    gtk_widget_show (label);
    gtk_notebook_append_page (GTK_NOTEBOOK (filenotebook), filelist, label);
    
    gtk_widget_show (filelist);
    gtk_widget_show (filenotebook);
    
    gtk_clist_append (filelist, temparr[0]);
    
    */
    
	/* create notebook */

    notebook = gtk_notebook_new ();
    gtk_notebook_set_tab_pos (GTK_NOTEBOOK(notebook), GTK_POS_TOP);
    
    
    
    gtk_container_add (GTK_CONTAINER(hbox), notebook);
   
    term = new_term (notebook, "/bin/tcsh", "", "tcsh");	
    
 



    gtk_signal_connect (GTK_OBJECT (window), "delete_event", GTK_SIGNAL_FUNC (quit_proggie),
		    NULL);
   
    
    
    /* show them all! */
    
    gtk_widget_show(notebook);
    gtk_widget_show (GTK_WIDGET(window));
    

     /* main loop */
    gtk_main ();
    gtk_exit(0);
    return 0;
  }



  
